module wangtest
use sep3d_struct_mod
use sep

implicit none
type(sep3d),private:: imagehead
integer,private :: nx,nz
real,allocatable,private :: imagedata(:,:)

contains

subroutine wangtest_init(nxfromoutside,nzfromoutside)
   integer :: nxfromoutside,nzfromoutside
   nx=nxfromoutside
   nz=nzfromoutside
   allocate(imagedata(nz,nx))
   call init_sep3d(imagehead, "OUTPUT","FLOAT", "REGULAR", ctag="Image")
   call axis_allocate(imagehead,2)
   imagehead%o(1)=0.0; imagehead%d(1)=1.0; imagehead%n(1)=nz
   imagehead%o(2)=0.0; imagehead%d(2)=1.0; imagehead%n(2)=nx
   call sep3d_set_sep3d(imagehead)
   call sep3d_write_description("Image",imagehead)
end subroutine wangtest_init

subroutine wangtest_release()
   deallocate(imagedata)
end subroutine wangtest_release

subroutine getimage(source,receiver)
   real::source(:,:),receiver(:,:)
   imagedata=source*receiver
end subroutine getimage

subroutine writeimage()
   integer,external:: srite
   if (srite("Image",imagedata,nx*nz*4)/=nx*nz*4) call seperr("err riting")
end subroutine writeimage


end module wangtest

